#include <stdio.h>
#include "BMP_include.h"

int BMP_OpenFile (char FName [], char FMode [], FILE *Fpnt);
void BMP_ShowError (int status);
int BMP_ReadHeader (FILE *FilePNT, unsigned char BMPheader []);
int BMP_GetSize (unsigned char BMPheader [], int *Righe, int *Colonne);
long int BMP_ReadImage (FILE *FilePNT, unsigned char BMPimage []);
void BMP_col2bw (unsigned char BMPimageIn [], unsigned char BMPimageOut [], long int InNbytes);

int main(int argc, char *argv []) {

   FILE *FileIn, *FileOut;
   unsigned char BMPheader   [54];
   unsigned char BMPimageIn  [1000 * 1000 * 3];
   unsigned char BMPimageOut [1000 * 1000 * 3];
   int Righe, Colonne, status;
   long int i, InNbytes;

   FileIn = fopen (argv [1], "rb");
   if (FileIn == NULL) BMP_ShowError (status);

   FileOut = fopen (argv [2], "wb");
   if (FileOut == NULL) BMP_ShowError (status);

   status = BMP_ReadHeader (FileIn, BMPheader);
   if (status != 0) BMP_ShowError (status);

   BMP_GetSize (BMPheader, &Righe, &Colonne);

   InNbytes = BMP_ReadImage (FileIn, BMPimageIn);

   BMP_col2bw (BMPimageIn, BMPimageOut, InNbytes);

   for (i=0; i<54; i++) fputc (BMPheader [i], FileOut);

   for (i=0; i<InNbytes; i++) fputc (BMPimageOut [i], FileOut);

   fclose (FileIn);
   fclose (FileOut);

}
